<?php
/**
 * TutorienPlugin.class.php
 *
 * Diese Datei enthlt die Hauptklasse des Plugins
 * @author 		Jan-Hendrik Willms <tleilax@mindfuck.de>
 * @author  	Michael Riehemann <michael.riehemann@uni-oldenburg.de>
 * @author  	Ivn Marcos <ivan.marcos@gmx.net>
 * @author  	Nico Mueller <nico.mueller@uni-oldenburg.de>
 * @package 	IBIT_TutorienPlugin
 * @copyright 	IBIT 2006-2010
 * @version 	2.1.7
 */

// Imports
require_once 'vendor/flexi/flexi.php';
require_once 'lib/classes/UserManagement.class.php';
require_once 'classes/Tutorien.class.php';
require_once 'classes/Tutorium.class.php';

// require
define('SAVE_ERROR_GENERAL', 0);
define('SAVE_OK', 1);
define('SAVE_ERROR_ACCESS', 2);

/**
 * Enter description here...
 *
 */
class TutorienPlugin extends AbstractStudIPStandardPlugin
{
	public $user;
	private $template_factory;
	private $permissions;
	private $message_OK = '<span style="color: green;">Eingabe erfolgreich &uuml;bernommen.</span>';
	private $message_NOK = '<span style="color: red;">Eingabe NICHT erfolgreich &uuml;bernommen.</span>';

	/**
	 * Enter description here...
	 *
	 */
	public function __construct()
	{
		// set navigation
		parent::AbstractStudIPStandardPlugin();
		$this->setPluginiconname('images/group.gif');

		$nav = new PluginNavigation();
		$nav->setDisplayname($this->getPluginname());
		$this->setNavigation($nav);

		$this->template_factory =& new Flexi_TemplateFactory(dirname(__FILE__).'/templates');

		$this->user = $this->getUser();
		$this->permissions = $this->user->getPermission();

		// Check for removed students and remove them from the tutorials as well
		$removed = DBManager::Get()->query("SELECT t.user_id FROM tutorium_student AS t LEFT JOIN seminar_user AS s ON (s.user_id=t.user_id AND s.Seminar_id=t.seminar_id) WHERE t.seminar_id='{$_SESSION['SessSemName'][1]}' AND s.Seminar_id IS NULL")->fetchAll(PDO::FETCH_COLUMN);
		if (!empty($removed))
		{
			DBManager::Get()->exec("DELETE FROM tutorium_student WHERE seminar_id='{$_SESSION['SessSemName'][1]}' AND user_id IN ('".implode("','", $removed)."')");
		}
	}

	/**
	 *
	 */
	function getPluginname()
	{
		return _('Tutorienbelegung');
	}

 	/**
	 *
	 */
	private function menuTeacherFormular($tutorials_complete)
	{
		# Startdate
		$start_date = array();
		if (!empty($_REQUEST['update']) and $_REQUEST['update']=='Y')
		{
			$start_date['year'] = $_REQUEST['start']['year'];
			$start_date['month'] = $_REQUEST['start']['month'];
			$start_date['day'] = $_REQUEST['start']['day'];
			$start_date['hour'] = $_REQUEST['start']['hour'];
			$start_date['minute'] = $_REQUEST['start']['minute'];
		}
		elseif (!empty($tutorials_complete->start_date))
		{
			$start_date['year'] = substr($tutorials_complete->start_date, 0, 4);
			$start_date['month'] = substr($tutorials_complete->start_date, 5, 2);
			$start_date['day'] = substr($tutorials_complete->start_date, 8, 2);
			$start_date['hour'] = substr($tutorials_complete->start_date, 11, 2);
			$start_date['minute'] = substr($tutorials_complete->start_date, 14, 2);
		}
		else
		{
			$tomorrow = strtotime('+1 day');
			$start_date['year'] = date('Y', $tomorrow);
			$start_date['month'] = date('m', $tomorrow);
			$start_date['day'] = date('d', $tomorrow);
			$start_date['hour'] = date('H', $tomorrow);
			$start_date['minute'] = date('i', $tomorrow);
		}
		$start_date['timestamp'] = mktime($start_date['hour'], $start_date['minute'], 0, $start_date['month'], $start_date['day'], $start_date['year']);

		# Enddate
		$end_date = array();
		if (!empty($_REQUEST['update']) and $_REQUEST['update']=='Y')
		{
			$end_date['year'] = $_REQUEST['end']['year'];
			$end_date['month'] = $_REQUEST['end']['month'];
			$end_date['day'] = $_REQUEST['end']['day'];
			$end_date['hour'] = $_REQUEST['end']['hour'];
			$end_date['minute'] = $_REQUEST['end']['minute'];
		}
		// set
		elseif (!empty($tutorials_complete->end_date))
		{
			$end_date['year'] = substr($tutorials_complete->end_date, 0, 4);
			$end_date['month'] = substr($tutorials_complete->end_date, 5, 2);
			$end_date['day'] = substr($tutorials_complete->end_date, 8, 2);
			$end_date['hour'] = substr($tutorials_complete->end_date, 11, 2);
			$end_date['minute'] = substr($tutorials_complete->end_date, 14, 2);
		}
		else
		{
			$one_week = strtotime('+1 week');
			$end_date['year'] = date('Y', $one_week);
			$end_date['month'] = date('m', $one_week);
			$end_date['day'] = date('d', $one_week);
			$end_date['hour'] = date('H', $one_week);
			$end_date['minute'] = date('i', $one_week);
		}
		$end_date['timestamp'] = mktime($end_date['hour'], $end_date['minute'], 0, $end_date['month'], $end_date['day'], $end_date['year']);

		$loop_number = (!empty($_REQUEST['update']) and $_REQUEST['update']=='Y') ? $_REQUEST['number'] : $tutorials_complete->number;

		$tutorials = array();
		# Tutorien auslesen
		foreach ($tutorials_complete->getTutorials(true) as $tutorial)
		{
			$tutorial['trash'] = $tutorial['id']>0;
			array_push($tutorials, $tutorial);
		}

		# Tutoren auslesen
		$tutors = DBManager::Get()->query("SELECT auth_user_md5.user_id AS id, username AS user_name, Vorname AS first_name, Nachname AS last_name FROM auth_user_md5 INNER JOIN seminar_user ON (auth_user_md5.user_id=seminar_user.user_id AND seminar_user.seminar_id='{$GLOBALS['SessSemName'][1]}' AND seminar_user.status IN ('tutor','dozent')) ORDER BY last_name ASC, first_name ASC")->fetchAll(PDO::FETCH_ASSOC);

		if (empty($tutors))
		{
			$tutors = DBManager::Get("SELECT user_id AS id, username AS user_name, Vorname AS first_name, Nachname AS last_name FROM auth_user_md5 WHERE username='notfound@studip'")->query()->fetchAll(PDO::FETCH_ASSOC);
		}

		$month_list = array(
			'1'=>_('Januar'),
			'2'=>_('Februar'),
			'3'=>_('Mrz'),
			'4'=>_('April'),
			'5'=>_('Mai'),
			'6'=>_('Juni'),
			'7'=>_('Juli'),
			'8'=>_('August'),
			'9'=>_('September'),
			'10'=>_('Oktober'),
			'11'=>_('November'),
			'12'=>_('Dezember')
		);

		$start_time = DBManager::Get()->query("SELECT start_time FROM seminare WHERE Seminar_id = '{$GLOBALS['SessSemName'][1]}'")->fetchColumn();
		$years = array(date('Y', $start_time));
		if (date('m', $start_time)>6)
		{
			array_push($years, date('Y', strtotime('+6 months', $start_time)));
		}

		$template = $this->template_factory->open($tutorials_complete->locked ? 'teacherformular_locked' : 'teacherformular');
		$template->set_attribute('tutorials_number', $tutorials_complete->number);
		$template->set_attribute('tutorials_selected', (!empty($_REQUEST['update']) and $_REQUEST['update']=='Y') ? $_REQUEST['number'] : $tutorials_complete->number);
		$template->set_attribute('start_date', $start_date);
		$template->set_attribute('end_date', $end_date);
		$template->set_attribute('years', $years);
		$template->set_attribute('months', $month_list);
		$template->set_attribute('links', array(
			'update'=>PluginEngine::getURL($this, array('update'=>'Y','number'=>'')),
			'submit'=>PluginEngine::getURL($this, array(), 'saveTeacherFormular'),
			'delete'=>PluginEngine::getURL($this, array('entry_id'=>''), 'deleteEntry'),
		));
		$template->set_attribute('tutorials', $tutorials);
		$template->set_attribute('tutors', $tutors);
		echo $template->render();
	}

	/**
	 * Enter description here...
	 *
	 * @return unknown
	 */
	private function checkTeacherFormular()
	{
		$errors = array();
		$array_number_fields = array(
			'number'=>_('Anzahl Tutorien'),
			'start'=>array(
				'day'=>_('Startanmeldungstag'),
				'month'=>_('Startanmeldungsmonat'),
				'year'=>_('Startanmeldungsjahr')
			),
			'end'=>array(
				'day' => _('Endanmeldungstag'),
				'month' => _('Endanmeldungsmonat'),
				'year' => _('Endanmeldungsjahr')
			)
		);
		# loop - no empty values and digits
		foreach($array_number_fields as $number_field=>$error_text )
		{
			if (is_array($error_text))
			{
				foreach ($error_text as $index=>$error)
				{
					$value = @$_REQUEST[$number_field][$index];
					if (empty($value) or !ctype_digit(trim($value)))
					{
						array_push($errors, sprintf(_('Bitte das Feld "%s" korrekt ausfllen.'), $error));
					}
				}
			}
			elseif (empty($_REQUEST[$number_field]) or !ctype_digit(trim($_REQUEST[$number_field])))
			{
				array_push($errors, sprintf(_('Bitte das Feld "%s" korrekt ausfllen.'), $error_text));
			}
		}

		# check dates
		if (!checkdate($_REQUEST['start']['month'], $_REQUEST['start']['day'], $_REQUEST['start']['year']))
		{
			array_push($errors, _('Bitte den Starttermin korrekt ausfllen.'));
		}
		// check dates
		if (!checkdate($_REQUEST['end']['month'], $_REQUEST['end']['day'], $_REQUEST['end']['year']))
		{
			array_push($errors, _('Bitte den Endtermin korrekt ausfllen.'));
		}
		$start_date = mktime($_REQUEST['start']['hour'], $_REQUEST['start']['minute'], 0, $_REQUEST['start']['month'], $_REQUEST['start']['day'], $_REQUEST['start']['year']);
		$end_date = mktime($_REQUEST['end']['hour'], $_REQUEST['end']['minute'], 0, $_REQUEST['end']['month'], $_REQUEST['end']['day'], $_REQUEST['end']['year']);
		// start_date before end_date?
		if ($end_date<$start_date)
		{
			array_push($errors, _('Der Endtermin darf nicht vor dem Starttermin liegen.'));
		}

		$counter = 1;
		foreach ($_REQUEST['values'] as $value)
		{
			if (empty($value['teacher']))
			{
				array_push($errors, sprintf(_('Reihe %d : Bitte whlen Sie einen Tutor.'),  $counter));
			}
			if (empty($value['time']))
			{
				array_push($errors, sprintf(_('Reihe %d : Bitte Feld "Termin" ausfllen.'), $counter));
			}
			if (empty($value['room']))
			{
				array_push($errors, sprintf(_('Reihe %d : Bitte Feld "Raum" ausfllen.'), $counter));
			}
			if (empty($value['max_size']) or !ctype_digit($value['max_size']) or $value['max_size']<0)
			{
				array_push($errors, sprintf(_('Reihe %d : Bitte Feld "Max. Gre" korrekt ausfllen.'), $counter));
			}
			$counter++;
		}

		return $errors;
	}

	/**
	 * Enter description here...
	 *
	 */
	private function overViewList($view = '')
	{
	    //tutoren und dozentenansicht
	    if($view == 'tutor')
	    {
    	    //manuelles hinzufgen eines teilnehmers zu einem tutorium
            if($_REQUEST['action'] == 'adduser')
            {
                $tutorial = new Tutorium($this->user, $_REQUEST['tutorium']);
                $result = $tutorial->addStudent($_REQUEST['user_id']);
                if($result == 1){
                    StudIPTemplateEngine::showSuccessMessage('Der Teilnehmer wurde erfolgreich dem Tutorium hinzugefgt.');
                } elseif($result == 2){
                    StudIPTemplateEngine::showSuccessMessage('Der Teilnehmer wurde erfolgreich in das Tutorium verschoben.');
                } else {
                     echo Messagebox::error('Der Teilnehmer ist bereits in diesem Tutorium eingetragen.');
                }
            }

    	    //manuelles lschen eines teilnehmers zu einem tutorium
            if($_REQUEST['action'] == 'delete')
            {
                $tutorial = new Tutorium($this->user, $_REQUEST['tutorium']);
                $result = $tutorial->deleteStudent($_REQUEST['user_id']);
                if($result == 1){
                    StudIPTemplateEngine::showSuccessMessage('Der Teilnehmer wurde erfolgreich aus dem Tutorium gelscht.');
                }
            }
            $template = $this->template_factory->open('overviewlist');
	    }
	    else
	    {
	        $template = $this->template_factory->open('student_overviewlist');
	    }

        $tutorials = new Tutorien($this->user, $GLOBALS['SessSemName'][1]);

		$template->set_attribute('tutorials', $tutorials->getTutorials());
		$template->set_attribute('users', $this->getSeminarUsers());
		$template->set_attribute('links', array(
			'this_page'=>PluginEngine::getLink($this),
		    'delete'=>PluginEngine::getLink($this, array('action' => 'delete'))
		));
		$template->set_attribute('user_self', $this->user->getUserName());
		echo $template->render();
	}

	/**
	 *
	 */
	private function getSeminarUsers()
	{
	    return DBManager::get()->query("SELECT au.user_id, au.Vorname, au.Nachname FROM seminar_user AS su LEFT JOIN auth_user_md5 AS au ON su.user_id=au.user_id WHERE su.Seminar_id = '{$GLOBALS['SessSemName'][1]}' AND su.status = 'autor' ORDER BY au.Nachname")->fetchAll(PDO::FETCH_ASSOC);
	}

	/**
	 *
	 * menu
	 *
	 *
	 */
	private function teacherView($errors=null)
	{
		// read the tutorial
		$tutorien = new Tutorien($this->user, $GLOBALS['SessSemName'][1]);

		if (!empty($_REQUEST['tutorial_id']))
		{
			$tutorien->tutoriums = array();

			$tutorials = array();
			foreach ($_REQUEST['tutorial_id'] as $id)
			{
				$tutorial = new Tutorium($this->user, $id);
				$values = $_REQUEST['values'][$id];

				$tutorial->teacher = !empty($values['teacher'])?$values['teacher']:$tutorial->teacher;
				$tutorial->time = !empty($values['time'])?$values['time']:$tutorial->time;
				$tutorial->room = !empty($values['room'])?$values['room']:$tutorial->room;
				$tutorial->max_size = !empty($values['max_size'])?$values['max_size']:$tutorial->max_size;

				array_push($tutorien->tutoriums, $tutorial);
			}
		}
		if (isset($_REQUEST['number']))
		{
			$tmp_id = -1;
			while (count($tutorien->tutoriums)<$_REQUEST['number'])
			{
				array_push($tutorien->tutoriums, new Tutorium($this->user, $tmp_id--));
			}
			while (count($tutorien->tutoriums)>$_REQUEST['number'])
			{
				array_pop($tutorien->tutoriums);
			}
		}

		// errors in red
		if (!empty($errors))
		{
			echo Messagebox::error('Fehler!', array($errors));
		}
		elseif ($_REQUEST['save_code']==SAVE_OK)
		{
			StudIPTemplateEngine::showSuccessMessage($this->message_OK);
		}
		elseif (isset($_REQUEST['save_code']) and $_REQUEST['save_code']==SAVE_ERROR_GENERAL)
		{
			echo Messagebox::error($this->message_NOK);
		}
		elseif ($_REQUEST['save_code']==SAVE_ERROR_ACCESS)
		{
			echo Messagebox::error('Sie haben keine Berechtigung.');
		}

		// formular
		$this->menuTeacherFormular($tutorien);

		// berblick
		//echo '<pre>',print_r($tutorien, true),'</pre>';
		//$this->overViewList($tutorien);
		$this->overViewList('tutor');

		StudIPTemplateEngine::createInfoboxTableCell();
		if ($tutorien->locked)
		{
			$infobox = array(
				array(
					'kategorie'=>_('Hinweis').':',
					'eintrag'=>array(
						array(
							'icon'=>'ausruf_small.gif',
							'text'=>_('Der Anmeldezeitraum ist beendet und die Gruppen wurden bereits erzeugt')
						),
						array(
							'icon'=>'blank.gif',
							'text'=>_('Smtliche nderung knnen nun nur noch ber die <a href="statusgruppen.php?view=statusgruppe_sem">Gruppenfunktionen</a> unter dem oberen Reiter "<a href="teilnehmer.php">TeilnehmerInnen</a>" vorgenommen werden.')
						)
					)
				)
			);
		}
		else
		{
			$infobox = array(
				array(
					'kategorie' => _('Anmerkungen:'),
					'eintrag' => array(
						array(
							'icon' => 'ausruf_small.gif',
							'text'  => _('Bereits eingerichtete Tutorien knnen nachtrglich in der Gre variiert werden.')
						),
						array(
							'icon' => 'ausruf_small.gif',
							'text'  => _('Die Teilnahme wird anhand des chronologischen Anmeldedatums bestimmt.')
						),
						array(
							'icon' => 'ausruf_small.gif',
							'text' => _('Falls die Gruppe nachtrglich verkleinert wird, so werden u.U. bereits angemeldete Teilnehmer entfernt.')
						)
					)
				)
			);
			if (strtotime($tutorien->end_date)<time())
			{
				$group_create_text  = '<form action="'.PluginEngine::getLink($this, array(), 'createGroups').'" method="post">';
				$group_create_text .= _('Gruppen ').makebutton('anlegen', 'input').'<br/>';
				$group_create_text .= '<input type="checkbox" name="create_folder" value="1" checked="checked"/>';
				$group_create_text .= _('Mit Dateiordnern').'<br/>';
				$group_create_text .= '<input type="checkbox" name="create_topic" value="1" checked="checked"/>';
				$group_create_text .= _('Mit Foreneintrgen').'<br/>';
				$group_create_text .= '</form>';

				array_push($infobox, array(
					'kategorie'=>_('Gruppenerzeugung').':',
					'eintrag'=>array(
						array(
							'icon'=>'termin-icon.gif',
							'text'=>_('Der Anmeldezeitraum fr die Tutorien ist abgelaufen. Sie knnen somit die Erfassung beenden und die Gruppenerzeugung fr die Tutorien ber den folgenden Link starten.')
						),
						array(
							'icon'=>'blank.gif',
							'text'=>$group_create_text
						),
						array(
							'icon'=>'ausruf_small.gif',
							'text'=>_('Beachten Sie, dass nach der Gruppenerzeugung keine nderungen an den Tutorien an dieser Stelle vorgenommen werden kann. Smtliche nderung mssen danach ber die Gruppenfunktionen unter dem oberen Reiter "TeilnehmerInnen" vorgenommen werden.')
						)
					)
				));
			}
			else
			{
				array_push($infobox, array(
					'kategorie'=>_('Gruppenerzeugung').':',
					'eintrag'=>array(
						array(
							'icon'=>'termin-icon.gif',
							'text'=>_('Nach Ablauf des Anmeldezeitraums haben Sie die Mglichkeit, Gruppen fr die jeweiligen Tutorien automatisch erzeugen zu lassen. An dieser Stelle wird in dem Falle ein entsprechender Link eingeblendet.')
						)
					)
				));
			}
		}
		print_infobox($infobox, 'wiki.jpg');
		StudIPTemplateEngine::endInfoBoxTableCell();
	}

	/**
	 * Enter description here...
	 *
	 */
	private function choiceView()
	{
		$tutorials = new Tutorien($this->user,$GLOBALS["SessSemName"][1]);

		if (isset($_REQUEST['save_code']))
		{
			if ($_REQUEST['save_code'] == SAVE_OK)
			{
				StudIPTemplateEngine::showSuccessMessage($this->message_OK);
			}
			elseif ($_REQUEST['save_code'] == SAVE_ERROR_GENERAL)
			{
				echo Messagebox::error($this->message_NOK);
			}
			elseif ($_REQUEST['save_code'] == SAVE_ERROR_ACCESS)
			{
				echo Messagebox::error('Sie haben keine Berechtigung.');
			}
		}

		$user_tutorial = DBManager::Get()->query("SELECT tutorium_id FROM tutorium_student WHERE seminar_id='{$GLOBALS['SessSemName'][1]}' AND user_id='{$this->user->getUserid()}'")->fetchColumn();

		$template = $this->template_factory->open('student_choice');
		$template->set_attribute('links', array(
			'submit'=>PluginEngine::getLink($this, array(), 'saveChoice')
		));
		$template->set_attribute('tutorials', $tutorials->getTutorials());
		$template->set_attribute('user_tutorial', $user_tutorial);
		$template->set_attribute('time_valid', strtotime($tutorials->start_date)<time() and strtotime($tutorials->end_date)>time());
		echo $template->render();


		//$this->overViewList($tutorials->number, $cssSw, $users_details, $tutor, $time, $room, $max_size, $id);
		$this->overViewList();

		StudIPTemplateEngine::createInfoBoxTableCell();
		// conversion
		$system_start_date = date('d.m.Y H:i', strtotime($tutorials->start_date));
		// conversion
		$system_end_date = date('d.m.Y H:i', strtotime($tutorials->end_date));
		// help
		$infobox = array(
			array(
				'kategorie' => _('Hinweise:'),
				'eintrag' => array(
					array(
						'icon' => 'ausruf_small.gif',
						'text'  => sprintf(_('Anmeldungen sind vom <b>%s</b> bis <b>%s</b> mglich.'), $system_start_date, $system_end_date)
					),
					array(
						'icon' => 'ausruf_small.gif',
						'text' => _('Ein grner Haken kennzeichnet das derzeit ausgewhlte Tutorium.')
					),
					array(
						'icon' => 'ausruf_small.gif',
						'text' => _('Ein rotes Kreuz kennzeichnet ein volles Tutorium. Eine Anmeldung hierzu ist nicht mglich.')
					)
				)
			)
		);
		print_infobox($infobox, 'warning.jpg');
		StudIPTemplateEngine::endInfoBoxTableCell();
	}

	/**
	 * Enter description here...
	 *
	 * @param unknown_type $destination
	 */
	private function redirect($destination)
	{
		#$destination = str_replace('&amp;', '&', $destination);

		#if (!preg_match('~^https?://~s', $destination))
		#{
		#	$destination = str_replace($GLOBALS['CANONICAL_RELATIVE_PATH_STUDIP'], '', $GLOBALS['ABSOLUTE_URI_STUDIP']).$destination;
		#}

		Header('Location: '.$destination);
		printf('<script type="text/javascript">window.location="%s";</script>', $destination);
		printf('<meta http-equiv="refresh" content="0; URL=%s"></meta>', $destination);
		die;
	}

	/**
	 * Enter description here...
	 *
	 */
	public function actionshow()
	{
		$is_tutor_or_dozent = DBManager::Get()->query("SELECT 1 FROM seminar_user WHERE Seminar_id='{$GLOBALS['SessSemName'][1]}' AND user_id='{$this->user->getUserid()}' AND status IN ('tutor', 'dozent')")->fetchColumn();
		// show - if teacher has the rights
		if ($is_tutor_or_dozent or $this->permissions->hasAdminPermission() or $this->permissions->hasRootPermission())
		{
			$this->teacherView();
		}
		// show - if autor
		elseif (DBManager::Get()->query("SELECT 1 FROM seminar_user WHERE Seminar_id='{$GLOBALS['SessSemName'][1]}' AND user_id='{$this->user->getUserid()}' AND status='autor'")->fetchColumn())
		{
			$this->choiceView();
		}
	}

	/**
	 * Enter description here...
	 *
	 * @return unknown
	 */
	public function actiondeleteEntry()
	{
		$is_tutor_or_dozent = DBManager::Get()->query("SELECT 1 FROM seminar_user WHERE Seminar_id='{$GLOBALS['SessSemName'][1]}' AND user_id='{$this->user->getUserid()}' AND status IN ('tutor', 'dozent')")->fetchColumn();
		if (!$is_tutor_or_dozent && !$this->permissions->hasAdminPermission() && !$this->permissions->hasRootPermission())
		{
			return $this->redirect(PluginEngine::getLink($this, array('save_code'=>SAVE_ERROR_ACCESS)));
		}

		$tutorium = new Tutorium($this->user, $_REQUEST['entry_id']);
		if ($tutorium->delete())
		{
			return $this->redirect(PluginEngine::getLink($this, array('save_code'=>SAVE_OK)));
		}
		$this->redirect(PluginEngine::getLink($this, array('save_code'=>SAVE_ERROR_GENERAL)));
	}

	/**
	 * Enter description here...
	 *
	 * @return unknown
	 */
	public function actionsaveTeacherFormular()
	{
		$is_tutor_or_dozent = DBManager::Get()->query("SELECT 1 FROM seminar_user WHERE Seminar_id='{$GLOBALS['SessSemName'][1]}' AND user_id='{$this->user->getUserid()}' AND status IN ('tutor', 'dozent')")->fetchColumn();
		// show - if teacher has the rights
		if (!$is_tutor_or_dozent && !$this->permissions->hasAdminPermission() &&!$this->permissions->hasRootPermission())
		{
			return $this->redirect(PluginEngine::getLink($this,array('save_code'=>SAVE_ERROR_ACCESS)));
		}

		// get errors
		$errors = $this->checkTeacherFormular();
		// check if errors
		if (!empty($errors))
		{
			$this->teacherView($errors);
			return;
		}
		$tutorials = new Tutorien($this->user, $GLOBALS['SessSemName'][1]);
		// set the values
		$tutorials->seminar_id = $GLOBALS['SessSemName'][1];
		$tutorials->number = $_REQUEST['number'];
		$tutorials->start_date = sprintf('%04d-%02d-%02d %02d-%02d-00', $_REQUEST['start']['year'], $_REQUEST['start']['month'], $_REQUEST['start']['day'], $_REQUEST['start']['hour'], $_REQUEST['start']['minute']);
		$tutorials->end_date = sprintf('%04d-%02d-%02d %02d-%02d-00', $_REQUEST['end']['year'], $_REQUEST['end']['month'], $_REQUEST['end']['day'], $_REQUEST['end']['hour'], $_REQUEST['end']['minute']);

		$tutorials->tutoriums = array();
		// set the values for the tutorium
		foreach ($_REQUEST['tutorial_id'] as $id)
		{
			$values = $_REQUEST['values'][$id];
			// load
			$tutorial = new Tutorium($this->user, $id);
			// modify
			$tutorial->seminar_id = $GLOBALS['SessSemName'][1];
			$tutorial->teacher = $values['teacher'];
			$tutorial->time	= $values['time'];
			$tutorial->room	= $values['room'];
			$tutorial->max_size = $values['max_size'];
			//
			array_push($tutorials->tutoriums, $tutorial);
		}
		while (count($tutorials->tutoriums)>$_REQUEST['number'])
		{
			array_pop($tutorials->tutoriums);
		}

		// save the tutorie
		if ($tutorials->save())
		{
			$this->redirect(PluginEngine::getLink($this,array('save_code'=>SAVE_OK)));
		}
		//
		else
		{
			// message
			$this->redirect(PluginEngine::getLink($this,array('save_code'=>SAVE_ERROR_GENERAL)));
		}
	}

	/**
	 * Enter description here...
	 *
	 */
	public function actioncreateGroups()
	{
		$seminar_id = $GLOBALS['SessSemName'][1];

		$tutorien = new Tutorien($this->user, $seminar_id);

		if ($tutorien->locked)
		{
			StudIPTemplateEngine::startContentTable();
			echo Messagebox::error(_('Die Gruppenerzeugung wurde bereits durchgefhrt und kann nicht erneut gestarter werden!'));
			StudIPTemplateEngine::endContentTable();
			return;
		}

		$tutorials = $tutorien->getTutorials();
		$template_tutorials = array();

		foreach ($tutorials as $index=>$tutorial)
		{
			$template_tutorial = array(
				'users'=>array(),
				'topic'=>false
			);
			if ($tutorial['participants']==0)
			{
				array_push($template_tutorials, $template_tutorial);
				continue;
			}

			$tutor_name = $tutorial['tutor']['first_name'].' '.$tutorial['tutor']['last_name'];

			$group_name = sprintf(_('Gruppe %d: %s, %s, %s'),
				$index+1,
				$tutor_name,
				$tutorial['time'],
				$tutorial['room']
			);

			$template_tutorial['tutor_name'] = $tutor_name;
			$template_tutorial['group_name'] = $group_name;

			$statusgruppe_id = AddNewStatusgruppe ($group_name, $seminar_id, $tutorial['max'], 0, !empty($_REQUEST['create_folder']));

			foreach ($tutorial['users'] as $user)
			{
				InsertPersonStatusgruppe($user['user_id'], $statusgruppe_id);
				array_push($template_tutorial['users'], $user['first_name'].' '.$user['last_name']);
			}

			if (!empty($_REQUEST['create_topic']))
			{
				$template_tutorial['topic'] = true;
				DBManager::Get()->exec("INSERT INTO px_topics (topic_id, parent_id, root_id, name, description, mkdate, chdate, author, user_id, Seminar_id, author_host) VALUES ('".md5($group_name)."', 0, '".md5($group_name)."', '{$group_name}', '".sprintf(_('Diskussionsforum von %s'), $group_name)."', UNIX_TIMESTAMP(), UNIX_TIMESTAMP(), '{$tutor_name}', '{$tutorial['tutor']['user_id']}', '{$seminar_id}', '{$_SERVER['REMOTE_ADDR']}')");
			}
			array_push($template_tutorials, $template_tutorial);
		}
		DBManager::Get()->exec("UPDATE tutorien SET locked=1 WHERE seminar_id='{$seminar_id}'");

		$template = $this->template_factory->open('group_creation');
		$template->set_attribute('tutorials', $template_tutorials);
		echo $template->render();

		StudIPTemplateEngine::startContentTable();
		StudIPTemplateEngine::showSuccessMessage(_('Die Gruppenerzeugung ist somit abgeschlossen.'));
		StudIPTemplateEngine::endContentTable();
	}

	/**
	 * Enter description here...
	 *
	 * @return unknown
	 */
	public function actionsaveChoice()
	{
		$is_student = DBManager::Get()->query("SELECT 1 FROM seminar_user WHERE Seminar_id='{$GLOBALS['SessSemName'][1]}' AND user_id='{$this->user->getUserid()}' AND status='autor'")->fetchColumn();
		if (!$is_student)
		{
			return $this->redirect(PluginEngine::getLink($this,array('save_code'=>SAVE_ERROR_ACCESS)));
		}

		if ($_REQUEST['selected_tutorial'] > 0)
		{
			$user_tutorial = DBManager::Get()->query("SELECT tutorium_id FROM tutorium_student WHERE seminar_id='{$GLOBALS['SessSemName'][1]}' AND user_id='{$this->user->userid}'")->fetchColumn();
			$user_tutorial = empty($user_tutorial) ? -1 : $user_tutorial;

			$tutorien = new Tutorien($this->user, $GLOBALS['SessSemName'][1]);
			$tutorials = $tutorien->getTutorials();
			$selected_tutorial = -1;
			foreach ($tutorials as $tutorial)
			{
				if ($tutorial['id']==$_REQUEST['selected_tutorial'])
				{
					$selected_tutorial = $tutorial;
				}
			}

			if ($user_tutorial==$selected_tutorial['id'])
			// User did not change his setting
			{
				$this->redirect(PluginEngine::getLink($this, array('save_code'=>SAVE_OK)));
			}

			if ($selected_tutorial['participants']<$selected_tutorial['max'] and strtotime($tutorien->start_date)<time() and strtotime($tutorien->end_date)>time())
			{
				$result = DBManager::Get()->exec("INSERT INTO tutorium_student (tutorium_id, seminar_id, user_id) VALUES ('{$_REQUEST['selected_tutorial']}', '{$GLOBALS['SessSemName'][1]}', '{$this->user->getUserid()}') ON DUPLICATE KEY UPDATE tutorium_id=VALUES(tutorium_id)");
				if ($result)
				{
					$this->redirect(PluginEngine::getLink($this, array('save_code'=>SAVE_OK)));
				}
				else
				{
					$this->redirect(PluginEngine::getLink($this, array('save_code'=>SAVE_ERROR_GENERAL, 'foo'=>'inside')));
				}
			}
			else
			{
				$this->redirect(PluginEngine::getLink($this, array('save_code'=>SAVE_ERROR_GENERAL)));
			}
		}
		else
		{
			DBManager::Get()->exec("DELETE FROM tutorium_student WHERE seminar_id='{$GLOBALS['SessSemName'][1]}' AND user_id='{$this->user->userid}'");
			$this->redirect(PluginEngine::getLink($this, array('save_code'=>SAVE_OK)));
		}
	}
}
?>