<?php
class Tutorien
{
	public $seminar_id,
		$start_date = '',
		$end_date	= '',
		$number	= 0,
		$tutoriums = array(),
		$locked = false,
		$debug = false;
	private $user;

	public function __construct($_user, $_seminar_id)
	{
		$this->user = $_user;

		if (empty($_seminar_id))
		{
			return;
		}
		$this->seminar_id = $_seminar_id;

		$data = DBManager::Get()->query("SELECT start_date, end_date, locked FROM tutorien WHERE seminar_id='{$this->seminar_id}' LIMIT 1")->fetch(PDO::FETCH_ASSOC);
		if ($data)
		{
			$this->locked = (bool)$data['locked'];
			$this->start_date = $data['start_date'];
			$this->end_date = $data['end_date'];
		}
  		// the other values
  		$this->setNumber();
		$this->setTutoriums();
	}

	public function getTutorials($all=false)
	{
		$tmp_tutorials = array_slice($this->tutoriums, 0, $all ? count($this->tutoriums) : $this->number);

		$tutorials = array();
		foreach ($tmp_tutorials as $tmp_tutorial)
		{
			array_push($tutorials, array(
				'id' => $tmp_tutorial->id,
				'time' => $tmp_tutorial->time,
				'room' => $tmp_tutorial->room,
				'max' => $tmp_tutorial->max_size,
				'tutor' => $tmp_tutorial->getTutor(),
				'users' => $tmp_tutorial->getUsersDetails(),
				'participants' => $tmp_tutorial->participants
			));
		}

		return $tutorials;
	}

	/**
	 * Enter description here...
	 *
	 * @return boolean
	 */
  	public function save()
	{
		if (!$this->user->getPermission()->hasTeacherPermissionInPOI() and !$this->user->getPermission()->hasTutorPermissionInPOI())
		{
			return false;
		}

		$present = DBManager::Get()->query("SELECT 1 FROM tutorien WHERE seminar_id='{$this->seminar_id}'")->fetchColumn();

		if ($present)
		{
			$formular_number = $this->number;
			$this->setNumber();
			if ($formular_number < $this->number)
			{
				return false;
			}
			$result = DBManager::Get()->exec("UPDATE tutorien SET start_date='{$this->start_date}', end_date='{$this->end_date}' WHERE seminar_id='{$this->seminar_id}'");
		}
		else
		{
			DBManager::Get()->exec("INSERT INTO tutorien (seminar_id, start_date, end_date) VALUES ('{$this->seminar_id}', '{$this->start_date}', '{$this->end_date}')");
		}

		foreach ($this->tutoriums as $tutorium)
		{
			$tutor_present = DBManager::Get()->query("SELECT COUNT(*) FROM auth_user_md5 INNER JOIN seminar_user ON (auth_user_md5.user_id=seminar_user.user_id AND seminar_user.seminar_id='{$this->seminar_id}' AND auth_user_md5.user_id='{$tutorium->teacher}' AND seminar_user.status IN ('tutor', 'dozent'))")->fetchColumn();

			if (!$tutor_present)
			{
				continue;
			}
			if ($tutorium->id>0)
			{
				DBManager::Get()->exec("UPDATE tutorium_main SET tutor='{$tutorium->teacher}', time='{$tutorium->time}', room='{$tutorium->room}', max_size='{$tutorium->max_size}' WHERE id='{$tutorium->id}'");

				$current_number = DBManager::Get()->query("SELECT COUNT(*) FROM tutorium_student WHERE tutorium_id='{$tutorium->id}' AND seminar_id='{$this->seminar_id}'")->fetchColumn();

				$students_to_remove = $current_number - intval($tutorium->max_size);
				if ($students_to_remove>0)
				{
					$deleted = DBManager::Get()->exec("DELETE FROM tutorium_student WHERE tutorium_id='{$tutorium->id}' AND seminar_id='{$this->seminar_id}' ORDER BY ts DESC LIMIT {$students_to_remove}");
					if ($deleted != $students_to_remove)
					{
						return false;
					}
				}
			}
			else
			{
				DBManager::Get()->exec("INSERT INTO tutorium_main (id, seminar_id, tutor, time, room, max_size) VALUES (NULL, '{$this->seminar_id}', '{$tutorium->teacher}', '{$tutorium->time}', '{$tutorium->room}', '{$tutorium->max_size}')");
			}
		}
		return true;
	}

	public function setNumber()
	{
		$this->number = DBManager::Get()->query("SELECT COUNT(*) FROM tutorium_main WHERE seminar_id='{$this->seminar_id}'")->fetchColumn();

		return true;
	}

	public function setTutoriums()
	{
		$ids = DBManager::Get()->query("SELECT id FROM tutorium_main WHERE seminar_id='{$this->seminar_id}' ORDER BY id ASC")->fetchAll(PDO::FETCH_COLUMN);
		foreach ($ids as $id)
		{
			array_push($this->tutoriums, new Tutorium($this->user, $id));
		}
	}
}
?>